module DualSet(DualSet, empty, full, singleton, complement, member, notMember,
    union, intersection, difference, fromList) where

import qualified Data.Set as Set
import Data.Set(Set)

data DualSet a = Pos (Set a) | Neg (Set a) deriving Show

empty = Pos Set.empty

full = Neg Set.empty

singleton a = Pos (Set.singleton a)

complement (Pos s) = Neg s
complement (Neg s) = Pos s

member e (Pos s) = Set.member e s
member e (Neg s) = Set.notMember e s

notMember e (Pos s) = Set.notMember e s
notMember e (Neg s) = Set.member e s

union (Pos s1) (Pos s2) = Pos (Set.union s1 s2)
union (Neg s1) (Neg s2) = Neg (Set.intersection s1 s2)
union (Neg s1) (Pos s2) = Neg (Set.difference s1 s2)
union (Pos s1) (Neg s2) = union (Neg s2) (Pos s1)

intersection s1 s2 = complement (union (complement s1) (complement s2))

difference s1 s2 = intersection s1 (complement s2)

fromList l = Pos (Set.fromList l)

